Ext.namespace("dSS", "dSS.config");

dSS.config.features = {};
dSS.config.settings = {};
dSS.config.dSSTimeDiff = 0;
dSS.config.firstLoad = true;

dSS.config.language = 'de_DE';
dSS.config.langPath = '/locale/' + dSS.config.language + '/LC_MESSAGES/' + 
                      'dss-langpack.json';

dSS.config.groups = {
    "VARIABLE"  : 0,
    "LIGHT"     : 1,
    "SHADOW"    : 2,
    "CLIMATE"   : 3,
    "AUDIO"     : 4,
    "VIDEO"     : 5,
    "SECURITY"  : 6,
    "ACCESS"    : 7,
    "JOKER"     : 8,
    "WHITE"     : 9,
    "DISPLAYS"  : 10
};

dSS.config.scenes = {
    "DEC"           : 11,
    "INC"           : 12,
    "MIN"           : 13,
    "MAX"           : 14,
    "STOP"          : 15,
    "T0_S0"         : 0,
    "T0_S1"         : 5,
    "T0_S2"         : 17,
    "T0_S3"         : 18,
    "T0_S4"         : 19,
    "T1_S0"         : 1,
    "T1_S1"         : 6,  // mood area 1
    "T2_S1"         : 7,  // mood area 2
    "T3_S1"         : 8,  // mood area 3
    "T4_S1"         : 9,  // mood area 4
    "EX5"           : 32, // mood 5
    "EX6"           : 33, // mood 6
    "T1_S2"         : 20, // mood 7
    "T1_S3"         : 21, // mood 8
    "T1_S4"         : 22, // mood 9
    "EX10"          : 34, // mood 10
    "EX11"          : 35, // mood 11
    "T2_S2"         : 23, // mood 12
    "T2_S3"         : 24, // mood 13
    "T2_S4"         : 25, // mood 14
    "EX15"          : 36, // mood 15
    "EX16"          : 37, // mood 16
    "T3_S2"         : 26, // mood 17
    "T3_S3"         : 27, // mood 18
    "T3_S4"         : 28, // mood 19
    "EX20"          : 38, // mood 20
    "EX21"          : 39, // mood 21
    "T4_S2"         : 29, // mood 22
    "T4_S3"         : 30, // mood 23
    "T4_S4"         : 31, // mood 24
    "LOCAL_OFF"     : 50,
    "LOCAL_ON"      : 51,
    "T1_STOP"       : 52,
    "T2_STOP"       : 53,
    "T3_STOP"       : 54,
    "T4_STOP"       : 55,
    "PANIC"         : 65,
    "STANDBY"       : 67,
    "DEEP_OFF"      : 68,
    "SLEEPING"      : 69,
    "WAKE_UP"       : 70,
    "PRESENT"       : 71,
    "ABSENT"        : 72,
    "SIG_BELL"      : 73
};

dSS.config.sceneNames = {
    0   : "Off",
    5   : "Scene 1",
    17  : "Scene 2",
    18  : "Scene 3",
    19  : "Scene 4",
    65  : "Panic",
    67  : "Standby",
    68  : "Deep off",
    69  : "Sleeping",
    70  : "Wake up",
    71  : "Coming home",
    72  : "Leave home",
    73  : "Door bell",
    6   : "Area 1 on",
    7   : "Area 2 on",
    8   : "Area 3 on",
    9   : "Area 4 on",
    32  : "Scene 10",
    33  : "Scene 11",
    20  : "Scene 12",
    21  : "Scene 13",
    22  : "Scene 14",
    34  : "Scene 20",
    35  : "Scene 21",
    23  : "Scene 22",
    24  : "Scene 23",
    25  : "Scene 24",
    36  : "Scene 30",
    37  : "Scene 31",
    26  : "Scene 32",
    27  : "Scene 33",
    28  : "Scene 34",
    38  : "Scene 40",
    39  : "Scene 41",
    29  : "Scene 42",
    30  : "Scene 43",
    31  : "Scene 44"
};

dSS.config.sceneTips = {
    0   : "Off = scene 0 (pushbutton scene 0-4)",
    5   : "Zone pushbutton scene 0-4",
    17  : "Zone pushbutton scene 0-4 / device pushbutton and area pushbutton scene 2-4",
    18  : "Zone pushbutton scene 0-4 / device pushbutton and area pushbutton scene 2-4",
    19  : "Zone pushbutton scene 0-4 / device pushbutton and area pushbutton scene 2-4",
    6   : "Area pushbutton 1",
    7   : "Area pushbutton 2",
    8   : "Area pushbutton 3",
    9   : "Area pushbutton 4",
    32  : "Zone pushbutton scene 10-14",
    33  : "Zone pushbutton scene 10-14",
    20  : "Zone pushbutton scene 10-14 / area pushbutton 1 scene 12-14",
    21  : "Zone pushbutton scene 10-14 / area pushbutton 1 scene 12-14",
    22  : "Zone pushbutton scene 10-14 / area pushbutton 1 scene 12-14",
    34  : "Zone pushbutton scene 20-24",
    35  : "Zone pushbutton scene 20-24",
    23  : "Zone pushbutton scene 20-24 / area pushbutton 2 scene 22-24",
    24  : "Zone pushbutton scene 20-24 / area pushbutton 2 scene 22-24",
    25  : "Zone pushbutton scene 20-24 / area pushbutton 2 scene 22-24",
    36  : "Zone pushbutton 30-34",
    37  : "Zone pushbutton 30-34",
    26  : "Zone pushbutton 30-34 / area pushbutton 3 scene 32-34",
    27  : "Zone pushbutton 30-34 / area pushbutton 3 scene 32-34",
    28  : "Zone pushbutton 30-34 / area pushbutton 3 scene 32-34",
    38  : "Zone pushbutton scene 40-44",
    39  : "Zone pushbutton scene 40-44",
    29  : "Zone pushbutton scene 40-44 / area pushbutton 4 scene 42-44",
    30  : "Zone pushbutton scene 40-44 / area pushbutton 4 scene 42-44",
    31  : "Zone pushbutton scene 40-44 / area pushbutton 4 scene 42-44"
};

dSS.config.sceneTipsShadowOverrides = {
    0   : "Down = scene 0 (pushbutton scene 0-4)",
    5   : "Up = scene 1 (pushbutton scene 0-4)"
};

dSS.config.sceneSortOrder = {
    0   : 0,
    5   : 1,
    17  : 2,
    18  : 3,
    19  : 4,
    6   : 5,
    7   : 6,
    8   : 7,
    9   : 8,
    32  : 9,
    33  : 10,
    20  : 11,
    21  : 12,
    22  : 13,
    34  : 15,
    35  : 16,
    23  : 17,
    24  : 18,
    25  : 19,
    36  : 20,
    37  : 21,
    26  : 22,
    27  : 23,
    28  : 24,
    38  : 25,
    39  : 26,
    29  : 27,
    30  : 28,
    31  : 29
};

dSS.config.deviceTypes = {
    0           : "KM" ,
    1           : "TKM",
    2           : "SDM",
    3           : "KL" ,
    4           : "TUP",
    5           : "ZWS",
    6           : "SDS"
};

dSS.config.deviceColors = {
    1           : "GE",
    2           : "GR",
    3           : "BL",
    4           : "TK",
    5           : "MG",
    6           : "RT",
    7           : "GN",
    8           : "SW",
    9           : "WE"
};

dSS.config.deviceParams = {
    "OUTPUT_MODE_DISABLED"          : 0,
    "OUTPUT_MODE_SWITCH"            : 16,
    "OUTPUT_MODE_DIMMER"            : 22,
    "OUTPUT_MODE_ALTSWITCH"         : 39,
    "OUTPUT_MODE_WIPE"              : 40,
    "OUTPUT_MODE_POWERSAVE"         : 41,

    "LED_CONFIG_ON"                 : 0,
    "LED_CONFIG_AUTO_DARK"          : 1,
    "LED_CONFIG_OFF"                : 2,

    "DIM_CONFIG_SELECT_STANDARD"    : 1,
    "DIM_CONFIG_SELECT_SLOW"        : 2,
    "DIM_CONFIG_SELECT_CUSTOM"      : 3,

    "PUSHBUTTON_DEVICE"             : 0,
    "PUSHBUTTON_GROUP1"             : 1,
    "PUSHBUTTON_GROUP2"             : 2,
    "PUSHBUTTON_GROUP3"             : 3,
    "PUSHBUTTON_GROUP4"             : 4,
    "PUSHBUTTON_ZONE0"              : 5,
    "PUSHBUTTON_ZONE1"              : 6,
    "PUSHBUTTON_ZONE2"              : 7,
    "PUSHBUTTON_ZONE3"              : 8,
    "PUSHBUTTON_ZONE4"              : 9,
    "PUSHBUTTON_GROUP5"             : 10,
    "PUSHBUTTON_GROUP6"             : 11,
    "PUSHBUTTON_GROUP7"             : 12,
    "PUSHBUTTON_GROUP8"             : 13,
    "PUSHBUTTON_APARTMENT"          : 14,
    "PUSHBUTTON_HIGHLEVEL"          : 15,
    
    "BUTTONINPUT_STANDARD"             : 0,
    "BUTTONINPUT_TURBO"                : 1,
    "BUTTONINPUT_SWITCH_STANDARD"      : 2,
    "BUTTONINPUT_SWITCH_EDGE"          : 3,
    "BUTTONINPUT_SWITCH_TIP"           : 4,
    "BUTTONINPUT_2WAY_DW_WITH_INPUT1"  : 5,
    "BUTTONINPUT_2WAY_DW_WITH_INPUT2"  : 6,
    "BUTTONINPUT_2WAY_DW_WITH_INPUT3"  : 7,
    "BUTTONINPUT_2WAY_DW_WITH_INPUT4"  : 8,
    "BUTTONINPUT_2WAY_UP_WITH_INPUT1"  : 9,
    "BUTTONINPUT_2WAY_UP_WITH_INPUT2"  : 10,
    "BUTTONINPUT_2WAY_UP_WITH_INPUT3"  : 11,
    "BUTTONINPUT_2WAY_UP_WITH_INPUT4"  : 12,
    "BUTTONINPUT_2WAY_UP_DOWN"         : 13,
    "BUTTONINPUT_SCENEDEVICE"          : 20
};

dSS.config.ButtonInputMode = {
    "BUTTONINPUT_1WAY"      : 0,
    "BUTTONINPUT_2WAY_DOWN" : 1,
    "BUTTONINPUT_2WAY_UP"   : 2
};

dSS.config.OutModeStrings = {
    0   : "disabled",
    16  : "switched",
    22  : "dimmed"
};

dSS.config.TitleIconCSSExt = 'Title';

dSS.config.GroupColorIconCls = {
    1           : "colorYellow",
    2           : "colorGrey",
    3           : "colorBlue",
    4           : "colorCyan",
    5           : "colorMagenta",
    6           : "colorRed",
    7           : "colorGreen",
    8           : "colorBlack",
    9           : "colorWhite"
};

dSS.config.GenericDeviceIconCls = {
    1           : "functionLight",
    2           : "functionShadow",
    3           : "functionClimate",
    4           : "functionAudio",
    5           : "functionVideo",
    6           : "functionSecurity",
    7           : "functionAccess",
    8           : "functionJoker",
    9           : "functionWhite"
};

dSS.config.KMIconCls = {
    1           : "functionLightKM",
    2           : "functionShadowKM",
    3           : "functionClimateKM",
    4           : "functionAudioKM",
    5           : "functionVideoKM",
    6           : "functionSecurityKM",
    7           : "functionAccessKM",
    8           : "functionJokerKM",
    9           : "functionWhiteKM"
};

dSS.config.TKMIconCls = {
    1           : "functionLightTKM",
    2           : "functionShadowTKM",
    3           : "functionClimateTKM",
    4           : "functionAudioTKM",
    5           : "functionVideoTKM",
    6           : "functionSecurityTKM",
    7           : "functionAccessTKM",
    8           : "functionJokerTKM",
    9           : "functionWhiteTKM"
};

dSS.config.SDMIconCls = {
    1           : "functionLightSDM",
    2           : "functionShadowSDM",
    3           : "functionClimateSDM",
    4           : "functionAudioSDM",
    5           : "functionVideoSDM",
    6           : "functionSecuritySDM",
    7           : "functionAccessSDM",
    8           : "functionJokerSDM",
    9           : "functionWhiteSDM"
};

dSS.config.KLIconCls = {
    1           : "functionLightKL",
    2           : "functionShadowKL",
    3           : "functionClimateKL",
    4           : "functionAudioKL",
    5           : "functionVideoKL",
    6           : "functionSecurityKL",
    7           : "functionAccessKL",
    8           : "functionJokerKL",
    9           : "functionWhiteKL"
};

dSS.config.ZWSIconCls = {
    1           : "functionLightZWS",
    2           : "functionShadowZWS",
    3           : "functionClimateZWS",
    4           : "functionAudioZWS",
    5           : "functionVideoZWS",
    6           : "functionSecurityZWS",
    7           : "functionAccessZWS",
    8           : "functionJokerZWS",
    9           : "functionWhiteZWS"
};

dSS.config.SDSIconCls = {
    1           : "functionLightSDS",
    2           : "functionShadowSDS",
    3           : "functionClimateSDS",
    4           : "functionAudioSDS",
    5           : "functionVideoSDS",
    6           : "functionSecuritySDS",
    7           : "functionAccessSDS",
    8           : "functionJokerSDS",
    9           : "functionWhiteSDS"
};

dSS.config.DeviceIconCSS = {
    0           : dSS.config.KMIconCls,
    1           : dSS.config.TKMIconCls,
    2           : dSS.config.SDMIconCls,
    3           : dSS.config.KLIconCls,
    4           : dSS.config.TKMIconCls,
    5           : dSS.config.ZWSIconCls,
    6           : dSS.config.SDSIconCls
};

dSS.config.TransmissionQuality = {
    "UPSTREAM_MAX"      : 62,
    "DOWNSTREAM_MAX"    : 6
};

dSS.config.FeatureConfig = {
    "SCENE"     : 0,
    "ZONE"      : 1,
    "CIRCUIT"   : 2
};

dSS.config.PushbuttonMinFW = 0x0314;
